<?php

namespace Unific\Extension\Helper\Data;

use Magento\Framework\Exception\InputException;
use Symfony\Component\Config\Definition\Exception\Exception;

class Category extends AbstractData
{
    protected $dataObjectConverter;

    // Holds a Product API DATA object
    protected $category;

    protected $returnData = array();

    /**
     * OrderPlugin constructor.
     * @param \Magento\Framework\App\Helper\Context $context
     * @param \Unific\Extension\Logger\Logger $logger
     * @param \Unific\Extension\Helper\Filter $filterHelper
     * @param \Magento\Framework\Api\ExtensibleDataObjectConverter $dataObjectConverter
     */
    public function __construct(
        \Magento\Framework\App\Helper\Context $context,
        \Unific\Extension\Logger\Logger $logger,
        \Unific\Extension\Helper\Filter $filterHelper,
        \Magento\Framework\Api\ExtensibleDataObjectConverter $dataObjectConverter
    )
    {
        $this->dataObjectConverter = $dataObjectConverter;

        parent::__construct($context, $logger, $filterHelper);
    }

    /**
     * @param \Magento\Catalog\Api\Data\CategoryInterface $category
     */
    public function setCategory(\Magento\Catalog\Api\Data\CategoryInterface $category)
    {
        $this->category = $category;
        $this->setCategoryInfo();
    }

    /**
     * @return \Magento\Catalog\Api\Data\CategoryInterface
     */
    public function getCategory()
    {
        return $this->category;
    }

    /**
     * @return void
     */
    protected function setCategoryInfo()
    {
        $this->returnData = $this->dataObjectConverter->toFlatArray($this->category, [], \Magento\Catalog\Api\Data\CategoryInterface::class);
    }

    /**
     * @return array
     */
    public function getCategoryInfo()
    {
        return $this->returnData;
    }
}
